# Go API client for swagger

 API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  

## Overview
This API client was generated by the [swagger-codegen](https://github.com/swagger-api/swagger-codegen) project.  By using the [swagger-spec](https://github.com/swagger-api/swagger-spec) from a remote server, you can easily generate an API client.

- API version: 2.0.0
- Package version: 1.0.0
- Build date: 2016-11-03T11:50:27.150+04:00
- Build package: class io.swagger.codegen.languages.GoClientCodegen

## Installation
Put the package under your project folder and add the following in import:
```
    "./swagger"
```

## Documentation for API Endpoints

All URIs are relative to *https://www.1gb.ru/api*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**BalanceGet**](docs/DefaultApi.md#balanceget) | **Get** /balance | Аккаунт: баланс
*DefaultApi* | [**BalanceLicGet**](docs/DefaultApi.md#balancelicget) | **Get** /balance.lic | Аккаунт: баланс аккаунта лицензий
*DefaultApi* | [**BillingDebtGet**](docs/DefaultApi.md#billingdebtget) | **Get** /billing/debt | Информация по дебету аккаунта
*DefaultApi* | [**BillingInfoGet**](docs/DefaultApi.md#billinginfoget) | **Get** /billing/info | Информация об аккаунте
*DefaultApi* | [**BillingLimitsGet**](docs/DefaultApi.md#billinglimitsget) | **Get** /billing/limits | Получить ограничения аккаунта
*DefaultApi* | [**DnsProlongListGet**](docs/DefaultApi.md#dnsprolonglistget) | **Get** /dns/prolong/list | Информация по продлению доменов
*DefaultApi* | [**EmailAddGet**](docs/DefaultApi.md#emailaddget) | **Get** /email/add | Создание почтового ящика
*DefaultApi* | [**EmailAliasDeleteGet**](docs/DefaultApi.md#emailaliasdeleteget) | **Get** /email/alias/delete | Удаление псевдонимов почтовых ящиков
*DefaultApi* | [**EmailAliasListGet**](docs/DefaultApi.md#emailaliaslistget) | **Get** /email/alias/list | Получить список псевдонимов почтовых ящиков
*DefaultApi* | [**EmailDeleteGet**](docs/DefaultApi.md#emaildeleteget) | **Get** /email/delete | Удаление почтового ящика
*DefaultApi* | [**EmailListGet**](docs/DefaultApi.md#emaillistget) | **Get** /email/list | Получить список почтовых ящиков
*DefaultApi* | [**UpdatesLastGet**](docs/DefaultApi.md#updateslastget) | **Get** /updates/last | Идентификатор последнего уведомления в аудите
*DefaultApi* | [**UpdatesListGet**](docs/DefaultApi.md#updateslistget) | **Get** /updates/list | Список записей аудита
*DefaultApi* | [**WebsiteDeleteGet**](docs/DefaultApi.md#websitedeleteget) | **Get** /website/delete | Удаление сайта
*DefaultApi* | [**WebsiteListGet**](docs/DefaultApi.md#websitelistget) | **Get** /website/list | Список сайтов аккаунта
*AuthAPIApi* | [**AuthLoginPost**](docs/AuthAPIApi.md#authloginpost) | **Post** /auth/login | Получить ключ доступа
*AuthAPIApi* | [**AuthStartGet**](docs/AuthAPIApi.md#authstartget) | **Get** /auth/start | Получить соль
*DNSApi* | [**DnsAddGet**](docs/DNSApi.md#dnsaddget) | **Get** /dns/add | Создание записи домена
*DNSApi* | [**DnsBindGet**](docs/DNSApi.md#dnsbindget) | **Get** /dns/bind | Привязка одного домена к другому
*DNSApi* | [**DnsListGet**](docs/DNSApi.md#dnslistget) | **Get** /dns/list | Получить список доменных имён
*DNSApi* | [**DnsProlongListGet**](docs/DNSApi.md#dnsprolonglistget) | **Get** /dns/prolong/list | Информация по продлению доменов
*DNSApi* | [**DnsRawGet**](docs/DNSApi.md#dnsrawget) | **Get** /dns/raw | Редактирование \&quot;сырой\&quot; зоны
*DNSApi* | [**DnsRawManagedmxGet**](docs/DNSApi.md#dnsrawmanagedmxget) | **Get** /dns/raw/managedmx | Редактировать DNS-зону
*HostingftpAPIApi* | [**FtpListGet**](docs/HostingftpAPIApi.md#ftplistget) | **Get** /ftp/list | Получить список зарегистрированных аккаунтов FTP
*HostingiisAPIApi* | [**IisListGet**](docs/HostingiisAPIApi.md#iislistget) | **Get** /iis/list | Список сайтов IIS
*MicrosoftSQLServerApi* | [**MssqlListGet**](docs/MicrosoftSQLServerApi.md#mssqllistget) | **Get** /mssql/list | Получить список аккаунтов в MSSQL
*MySQLPostgresApi* | [**DatabaseListGet**](docs/MySQLPostgresApi.md#databaselistget) | **Get** /database/list | Список аккаунтов в базах данных UNIX
*VDSHyperVOpenVZApi* | [**VdsCreateGet**](docs/VDSHyperVOpenVZApi.md#vdscreateget) | **Get** /vds/create | Изменение параметров VDS
*VDSHyperVOpenVZApi* | [**VdsDeleteGet**](docs/VDSHyperVOpenVZApi.md#vdsdeleteget) | **Get** /vds/delete | Удаление VDS
*VDSHyperVOpenVZApi* | [**VdsIpAddGet**](docs/VDSHyperVOpenVZApi.md#vdsipaddget) | **Get** /vds/ip/add | Добавление IP на VDS
*VDSHyperVOpenVZApi* | [**VdsIpDeleteGet**](docs/VDSHyperVOpenVZApi.md#vdsipdeleteget) | **Get** /vds/ip/delete | Удаление IP с VDS
*VDSHyperVOpenVZApi* | [**VdsIpListGet**](docs/VDSHyperVOpenVZApi.md#vdsiplistget) | **Get** /vds/ip/list | Список IP-адресов виртуальных серверов
*VDSHyperVOpenVZApi* | [**VdsListGet**](docs/VDSHyperVOpenVZApi.md#vdslistget) | **Get** /vds/list | Список виртуальных серверов
*VDSHyperVOpenVZApi* | [**VdsRebootGet**](docs/VDSHyperVOpenVZApi.md#vdsrebootget) | **Get** /vds/reboot | Перезагрузка VDS
*VDSHyperVOpenVZApi* | [**VdsTemplatesListGet**](docs/VDSHyperVOpenVZApi.md#vdstemplateslistget) | **Get** /vds/templates-list | Список шаблонов виртуальных серверов
*VDSHyperVOpenVZApi* | [**VdsUpdateGet**](docs/VDSHyperVOpenVZApi.md#vdsupdateget) | **Get** /vds/update | Создание VDS


## Documentation For Models

 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse20010](docs/InlineResponse20010.md)
 - [InlineResponse20011](docs/InlineResponse20011.md)
 - [InlineResponse20012](docs/InlineResponse20012.md)
 - [InlineResponse20013](docs/InlineResponse20013.md)
 - [InlineResponse20014](docs/InlineResponse20014.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse2008](docs/InlineResponse2008.md)
 - [InlineResponse2009](docs/InlineResponse2009.md)
 - [_](docs/_.md)


## Documentation For Authorization

 All endpoints do not require authorization.


## Author



