/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package swagger

import (
	"strings"
	"fmt"
	"errors"
	"net/url"
	"encoding/json"
)

type DNSApi struct {
	Configuration Configuration
}

func NewDNSApi() *DNSApi {
	configuration := NewConfiguration()
	return &DNSApi{
		Configuration: *configuration,
	}
}

func NewDNSApiWithBasePath(basePath string) *DNSApi {
	configuration := NewConfiguration()
	configuration.BasePath = basePath

	return &DNSApi{
		Configuration: *configuration,
	}
}

/**
 * Создание записи домена
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param addDnsZone зона, которую необходимо создать
 * @param addDnsRecord 
 * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
 * @param bindOnly 
 * @return *string
 */
func (a DNSApi) DnsAddGet(token_ string, addDnsZone string, addDnsRecord string, iisSiteForDns string, bindOnly bool) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/dns/add"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling DNSApi->DnsAddGet")
	}
	// verify the required parameter 'addDnsZone' is set
	if &addDnsZone == nil {
		return new(string), nil, errors.New("Missing required parameter 'addDnsZone' when calling DNSApi->DnsAddGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("addDnsZone", a.Configuration.APIClient.ParameterToString(addDnsZone, ""))
			queryParams.Add("addDnsRecord", a.Configuration.APIClient.ParameterToString(addDnsRecord, ""))
			queryParams.Add("iisSiteForDns", a.Configuration.APIClient.ParameterToString(iisSiteForDns, ""))
			queryParams.Add("bindOnly", a.Configuration.APIClient.ParameterToString(bindOnly, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Привязка одного домена к другому
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID домена из списка /dns/list
 * @param bindTo домен, к которому необходимо сделать привязку
 * @return *string
 */
func (a DNSApi) DnsBindGet(token_ string, key_ int32, bindTo string) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/dns/bind"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling DNSApi->DnsBindGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling DNSApi->DnsBindGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
			queryParams.Add("bindTo", a.Configuration.APIClient.ParameterToString(bindTo, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Получить список доменных имён
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @return []InlineResponse2003
 */
func (a DNSApi) DnsListGet(token_ string) ([]InlineResponse2003, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/dns/list"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new([]InlineResponse2003), nil, errors.New("Missing required parameter 'token_' when calling DNSApi->DnsListGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new([]InlineResponse2003)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Информация по продлению доменов
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @return []InlineResponse2004
 */
func (a DNSApi) DnsProlongListGet(token_ string) ([]InlineResponse2004, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/dns/prolong/list"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new([]InlineResponse2004), nil, errors.New("Missing required parameter 'token_' when calling DNSApi->DnsProlongListGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new([]InlineResponse2004)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Редактирование \&quot;сырой\&quot; зоны
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID домена из /dns/list
 * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
 * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
 * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
 * @param dnsName Имя записи, либо &#39;@&#39; для корневой
 * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
 * @return *string
 */
func (a DNSApi) DnsRawGet(token_ string, key_ int32, sDel int32, sAdd int32, dnsType string, dnsName string, dnsValue string) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/dns/raw"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling DNSApi->DnsRawGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling DNSApi->DnsRawGet")
	}
	// verify the required parameter 'sDel' is set
	if &sDel == nil {
		return new(string), nil, errors.New("Missing required parameter 'sDel' when calling DNSApi->DnsRawGet")
	}
	// verify the required parameter 'sAdd' is set
	if &sAdd == nil {
		return new(string), nil, errors.New("Missing required parameter 'sAdd' when calling DNSApi->DnsRawGet")
	}
	// verify the required parameter 'dnsType' is set
	if &dnsType == nil {
		return new(string), nil, errors.New("Missing required parameter 'dnsType' when calling DNSApi->DnsRawGet")
	}
	// verify the required parameter 'dnsName' is set
	if &dnsName == nil {
		return new(string), nil, errors.New("Missing required parameter 'dnsName' when calling DNSApi->DnsRawGet")
	}
	// verify the required parameter 'dnsValue' is set
	if &dnsValue == nil {
		return new(string), nil, errors.New("Missing required parameter 'dnsValue' when calling DNSApi->DnsRawGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
			queryParams.Add("sDel", a.Configuration.APIClient.ParameterToString(sDel, ""))
			queryParams.Add("sAdd", a.Configuration.APIClient.ParameterToString(sAdd, ""))
			queryParams.Add("dnsType", a.Configuration.APIClient.ParameterToString(dnsType, ""))
			queryParams.Add("dnsName", a.Configuration.APIClient.ParameterToString(dnsName, ""))
			queryParams.Add("dnsValue", a.Configuration.APIClient.ParameterToString(dnsValue, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Редактировать DNS-зону
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID домена из /dns/list
 * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
 * @param updManagedMx Значение &#39;1&#39; подтверждает операцию
 * @return *string
 */
func (a DNSApi) DnsRawManagedmxGet(token_ string, key_ int32, managedMx int32, updManagedMx int32) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/dns/raw/managedmx"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling DNSApi->DnsRawManagedmxGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling DNSApi->DnsRawManagedmxGet")
	}
	// verify the required parameter 'managedMx' is set
	if &managedMx == nil {
		return new(string), nil, errors.New("Missing required parameter 'managedMx' when calling DNSApi->DnsRawManagedmxGet")
	}
	// verify the required parameter 'updManagedMx' is set
	if &updManagedMx == nil {
		return new(string), nil, errors.New("Missing required parameter 'updManagedMx' when calling DNSApi->DnsRawManagedmxGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
			queryParams.Add("managedMx", a.Configuration.APIClient.ParameterToString(managedMx, ""))
			queryParams.Add("updManagedMx", a.Configuration.APIClient.ParameterToString(updManagedMx, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

