# \DNSApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DnsAddGet**](DNSApi.md#DnsAddGet) | **Get** /dns/add | Создание записи домена
[**DnsBindGet**](DNSApi.md#DnsBindGet) | **Get** /dns/bind | Привязка одного домена к другому
[**DnsListGet**](DNSApi.md#DnsListGet) | **Get** /dns/list | Получить список доменных имён
[**DnsProlongListGet**](DNSApi.md#DnsProlongListGet) | **Get** /dns/prolong/list | Информация по продлению доменов
[**DnsRawGet**](DNSApi.md#DnsRawGet) | **Get** /dns/raw | Редактирование \&quot;сырой\&quot; зоны
[**DnsRawManagedmxGet**](DNSApi.md#DnsRawManagedmxGet) | **Get** /dns/raw/managedmx | Редактировать DNS-зону


# **DnsAddGet**
> string DnsAddGet($token_, $addDnsZone, $addDnsRecord, $iisSiteForDns, $bindOnly)

Создание записи домена


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **addDnsZone** | **string**| зона, которую необходимо создать | 
 **addDnsRecord** | **string**|  | [optional] 
 **iisSiteForDns** | **string**| ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку | [optional] 
 **bindOnly** | **bool**|  | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DnsBindGet**
> string DnsBindGet($token_, $key_, $bindTo)

Привязка одного домена к другому


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID домена из списка /dns/list | 
 **bindTo** | **string**| домен, к которому необходимо сделать привязку | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DnsListGet**
> []InlineResponse2003 DnsListGet($token_)

Получить список доменных имён


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse2003**](inline_response_200_3.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DnsProlongListGet**
> []InlineResponse2004 DnsProlongListGet($token_)

Информация по продлению доменов


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse2004**](inline_response_200_4.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DnsRawGet**
> string DnsRawGet($token_, $key_, $sDel, $sAdd, $dnsType, $dnsName, $dnsValue)

Редактирование \"сырой\" зоны


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID домена из /dns/list | 
 **sDel** | **int32**| Значение &#39;1&#39; сообщает, что запись необходимо удалить | 
 **sAdd** | **int32**| Значение &#39;1&#39; сообщает, что запись необходимо создать | 
 **dnsType** | **string**| Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV | 
 **dnsName** | **string**| Имя записи, либо &#39;@&#39; для корневой | 
 **dnsValue** | **string**| Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DnsRawManagedmxGet**
> string DnsRawManagedmxGet($token_, $key_, $managedMx, $updManagedMx)

Редактировать DNS-зону


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID домена из /dns/list | 
 **managedMx** | **int32**| Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить | 
 **updManagedMx** | **int32**| Значение &#39;1&#39; подтверждает операцию | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

