# \DefaultApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**BalanceGet**](DefaultApi.md#BalanceGet) | **Get** /balance | Аккаунт: баланс
[**BalanceLicGet**](DefaultApi.md#BalanceLicGet) | **Get** /balance.lic | Аккаунт: баланс аккаунта лицензий
[**BillingDebtGet**](DefaultApi.md#BillingDebtGet) | **Get** /billing/debt | Информация по дебету аккаунта
[**BillingInfoGet**](DefaultApi.md#BillingInfoGet) | **Get** /billing/info | Информация об аккаунте
[**BillingLimitsGet**](DefaultApi.md#BillingLimitsGet) | **Get** /billing/limits | Получить ограничения аккаунта
[**DnsProlongListGet**](DefaultApi.md#DnsProlongListGet) | **Get** /dns/prolong/list | Информация по продлению доменов
[**EmailAddGet**](DefaultApi.md#EmailAddGet) | **Get** /email/add | Создание почтового ящика
[**EmailAliasDeleteGet**](DefaultApi.md#EmailAliasDeleteGet) | **Get** /email/alias/delete | Удаление псевдонимов почтовых ящиков
[**EmailAliasListGet**](DefaultApi.md#EmailAliasListGet) | **Get** /email/alias/list | Получить список псевдонимов почтовых ящиков
[**EmailDeleteGet**](DefaultApi.md#EmailDeleteGet) | **Get** /email/delete | Удаление почтового ящика
[**EmailListGet**](DefaultApi.md#EmailListGet) | **Get** /email/list | Получить список почтовых ящиков
[**UpdatesLastGet**](DefaultApi.md#UpdatesLastGet) | **Get** /updates/last | Идентификатор последнего уведомления в аудите
[**UpdatesListGet**](DefaultApi.md#UpdatesListGet) | **Get** /updates/list | Список записей аудита
[**WebsiteDeleteGet**](DefaultApi.md#WebsiteDeleteGet) | **Get** /website/delete | Удаление сайта
[**WebsiteListGet**](DefaultApi.md#WebsiteListGet) | **Get** /website/list | Список сайтов аккаунта


# **BalanceGet**
> float32 BalanceGet($token_)

Аккаунт: баланс

Возвращает текущий баланс аккаунта


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

**float32**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **BalanceLicGet**
> float32 BalanceLicGet($token_)

Аккаунт: баланс аккаунта лицензий

Возвращает текущий баланс аккаунта лицензий


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

**float32**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **BillingDebtGet**
> []InlineResponse200 BillingDebtGet($token_)

Информация по дебету аккаунта

Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse200**](inline_response_200.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **BillingInfoGet**
> []InlineResponse2001 BillingInfoGet($token_)

Информация об аккаунте

Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse2001**](inline_response_200_1.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **BillingLimitsGet**
> _ BillingLimitsGet($token_)

Получить ограничения аккаунта


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**_**]( .md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **DnsProlongListGet**
> []InlineResponse2004 DnsProlongListGet($token_)

Информация по продлению доменов


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse2004**](inline_response_200_4.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **EmailAddGet**
> string EmailAddGet($token_, $addEmail)

Создание почтового ящика


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **addEmail** | **string**| Адрес почтового ящика, который необходимо создать | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **EmailAliasDeleteGet**
> string EmailAliasDeleteGet($token_, $key_)

Удаление псевдонимов почтовых ящиков


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **string**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **EmailAliasListGet**
> []InlineResponse2005 EmailAliasListGet($token_)

Получить список псевдонимов почтовых ящиков


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse2005**](inline_response_200_5.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **EmailDeleteGet**
> string EmailDeleteGet($token_, $key_)

Удаление почтового ящика


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **string**| Адрес почтового ящика, подлежащего удалению | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **EmailListGet**
> []InlineResponse2006 EmailListGet($token_)

Получить список почтовых ящиков


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse2006**](inline_response_200_6.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UpdatesLastGet**
> int32 UpdatesLastGet($token_)

Идентификатор последнего уведомления в аудите


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

**int32**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **UpdatesListGet**
> []InlineResponse20010 UpdatesListGet($token_, $key_)

Список записей аудита


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID первой записи для показа или 0 для показа всех записей | 

### Return type

[**[]InlineResponse20010**](inline_response_200_10.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **WebsiteDeleteGet**
> string WebsiteDeleteGet($token_, $key_)

Удаление сайта


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **string**| ID сайта, полученный из /website/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **WebsiteListGet**
> []InlineResponse20014 WebsiteListGet($token_)

Список сайтов аккаунта


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse20014**](inline_response_200_14.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

