# \VDSHyperVOpenVZApi

All URIs are relative to *https://www.1gb.ru/api*

Method | HTTP request | Description
------------- | ------------- | -------------
[**VdsCreateGet**](VDSHyperVOpenVZApi.md#VdsCreateGet) | **Get** /vds/create | Изменение параметров VDS
[**VdsDeleteGet**](VDSHyperVOpenVZApi.md#VdsDeleteGet) | **Get** /vds/delete | Удаление VDS
[**VdsIpAddGet**](VDSHyperVOpenVZApi.md#VdsIpAddGet) | **Get** /vds/ip/add | Добавление IP на VDS
[**VdsIpDeleteGet**](VDSHyperVOpenVZApi.md#VdsIpDeleteGet) | **Get** /vds/ip/delete | Удаление IP с VDS
[**VdsIpListGet**](VDSHyperVOpenVZApi.md#VdsIpListGet) | **Get** /vds/ip/list | Список IP-адресов виртуальных серверов
[**VdsListGet**](VDSHyperVOpenVZApi.md#VdsListGet) | **Get** /vds/list | Список виртуальных серверов
[**VdsRebootGet**](VDSHyperVOpenVZApi.md#VdsRebootGet) | **Get** /vds/reboot | Перезагрузка VDS
[**VdsTemplatesListGet**](VDSHyperVOpenVZApi.md#VdsTemplatesListGet) | **Get** /vds/templates-list | Список шаблонов виртуальных серверов
[**VdsUpdateGet**](VDSHyperVOpenVZApi.md#VdsUpdateGet) | **Get** /vds/update | Создание VDS


# **VdsCreateGet**
> string VdsCreateGet($token_, $type_, $crHvmem, $crHvdsk, $crHvcpu, $template, $forceMemo, $hv1gbPanelVersion, $panelInstall, $crSsd1, $crHvAllSystem)

Изменение параметров VDS

Изменение параметров уже существующего VDS


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **type_** | **string**| Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; | [optional] 
 **crHvmem** | **int32**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **crHvdsk** | **int32**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **crHvcpu** | **int32**| Количество ядер CPU. По умолчанию 2 | [optional] 
 **template** | **string**| Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list | [optional] 
 **forceMemo** | **string**|  | [optional] 
 **hv1gbPanelVersion** | **string**|  | [optional] 
 **panelInstall** | **bool**| Необходимо ли установить панель 1Gb на VDS | [optional] 
 **crSsd1** | **bool**| Создать всю систему на SSD | [optional] 
 **crHvAllSystem** | **bool**| Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsDeleteGet**
> string VdsDeleteGet($token_, $key_, $forceCritical)

Удаление VDS

Предоставляет функционал для удаления VDS


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID виртуального сервера, полученный из /vds/list | 
 **forceCritical** | **bool**| Если true, VDS будет удален срочно | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsIpAddGet**
> string VdsIpAddGet($token_, $key_)

Добавление IP на VDS

Этот вызов позволяет добавить ещё один IP адрес на указанный VDS


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsIpDeleteGet**
> string VdsIpDeleteGet($token_, $key_, $delIp)

Удаление IP с VDS

Этот вызов позволяет отвязать IP адрес от VDS


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID виртуального сервера, полученный из /vds/list | 
 **delIp** | **string**| IP адрес, который необходимо удалить | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsIpListGet**
> []InlineResponse20011 VdsIpListGet($token_, $key_)

Список IP-адресов виртуальных серверов

Список IP-адресов виртуальных серверов


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID виртуального сервера, полученный из /vds/list | [optional] 

### Return type

[**[]InlineResponse20011**](inline_response_200_11.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsListGet**
> []InlineResponse20012 VdsListGet($token_, $key_)

Список виртуальных серверов

Позволяет получить список виртуальных серверов


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS | [optional] 

### Return type

[**[]InlineResponse20012**](inline_response_200_12.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsRebootGet**
> string VdsRebootGet($token_, $key_)

Перезагрузка VDS

Предоставляет функционал для перезагрузки VDS


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID виртуального сервера, полученный из /vds/list | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsTemplatesListGet**
> []InlineResponse20013 VdsTemplatesListGet($token_)

Список шаблонов виртуальных серверов

Позволяет получить список шаблонов виртуальных серверов


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 

### Return type

[**[]InlineResponse20013**](inline_response_200_13.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **VdsUpdateGet**
> string VdsUpdateGet($token_, $key_, $crHvmem, $crHvdsk, $crHvcpu)

Создание VDS

Создание новых VDS с произвольными характеристиками


### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **token_** | **string**| Ключ доступа, полученный при авторизации | 
 **key_** | **int32**| ID виртуального сервера, полученный из /vds/list | 
 **crHvmem** | **int32**| Количество доступной памяти в мегабайтах. По умолчанию 2048 | [optional] 
 **crHvdsk** | **int32**| Количество доступных гигабайт диска. По умолчанию 30 | [optional] 
 **crHvcpu** | **int32**| Количество ядер CPU. По умолчанию 2 | [optional] 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

