/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package swagger

type InlineResponse2001 struct {

	// Идентификатор аккаунта
	Id int32 `json:"id,omitempty"`

	// Описание аккаунта
	Description string `json:"description,omitempty"`

	// Идентификатор тарифной группы
	BillingGroupId int32 `json:"billing_group_id,omitempty"`

	// Аккаунт заблокирован, если true
	Blocked string `json:"blocked,omitempty"`

	// Дата блокировки
	BlockedDate string `json:"blocked_date,omitempty"`

	// Причина блокировки
	BlockedReason string `json:"blocked_reason,omitempty"`

	// Ограничение суммы на работу в аванс
	CreditLimit float32 `json:"credit_limit,omitempty"`

	// Идентификатор тарифа
	PlanId int32 `json:"plan_id,omitempty"`

	// Идентификатор тарифа (периода)
	PeriodId int32 `json:"period_id,omitempty"`

	// Тип договора
	ContractType int32 `json:"contract_type,omitempty"`

	// 
	ClientId int32 `json:"client_id,omitempty"`

	// Логин клиента
	ClientLogin string `json:"client_login,omitempty"`

	// Номер договора
	ContractId string `json:"contract_id,omitempty"`

	// Имя клиента на русском
	NameRus string `json:"name_rus,omitempty"`

	// Имя клиента на английском
	NameEng string `json:"name_eng,omitempty"`

	// E-mail клиент
	Email string `json:"email,omitempty"`

	// Количество созданных сайтов
	StatSites int32 `json:"stat_sites,omitempty"`

	// Используемое дисковое пространство
	StatSizeMb int32 `json:"stat_size_mb,omitempty"`

	// Количество созданных почтовых ящиков
	StatEmails int32 `json:"stat_emails,omitempty"`

	// Количество баз данных MySQL
	StatMysqls int32 `json:"stat_mysqls,omitempty"`

	// 
	StatTech int32 `json:"stat_tech,omitempty"`

	// 
	StatNicd int32 `json:"stat_nicd,omitempty"`

	// 
	StatAccessDynamic int32 `json:"stat_access_dynamic,omitempty"`

	// 
	StatAccessStatic int32 `json:"stat_access_static,omitempty"`

	// 
	StatAccessTraffic int32 `json:"stat_access_traffic,omitempty"`

	// 
	StatPaidTotal int32 `json:"stat_paid_total,omitempty"`

	// Размер дисков VDS
	StatVdsSize int32 `json:"stat_vds_size,omitempty"`

	// Название тарифного плана
	PlanName string `json:"__plan_name,omitempty"`

	// Количество месяцев в оплаченном периоде
	PeriodMonths int32 `json:"__period_months,omitempty"`

	// Стоимость оплаченного периода
	PeriodPrice float32 `json:"__period_price,omitempty"`

	// 
	Expires string `json:"__expires,omitempty"`

	// Префикс для вывода текущей валюты хостинга (например, в строке '$100' префиксом является '$')
	ExternalCurrencySpelledPrefix string `json:"external_currency_spelled_prefix,omitempty"`

	// Суффикс для вывода текущей валюты хостинга (например, в строке '100 руб.' суффиксом является ' руб.'
	ExternalCurrencySpelledSuffix string `json:"external_currency_spelled_suffix,omitempty"`
}
