/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package swagger

type InlineResponse20014 struct {

	// 
	Id int32 `json:"id,omitempty"`

	// 
	Status string `json:"status,omitempty"`

	// 
	Unmovable string `json:"unmovable,omitempty"`

	// Включен (активен), если true.
	Online string `json:"online,omitempty"`

	// Удален, если true. Данные могут сохраняться.
	Deleted string `json:"deleted,omitempty"`

	// Удален, если true. Данные могут сохраняться.
	DeletedAuto string `json:"deleted_auto,omitempty"`

	// 
	DeletedDump string `json:"deleted_dump,omitempty"`

	// 
	UserId string `json:"user_id,omitempty"`

	// 
	FtpId string `json:"ftp_id,omitempty"`

	// 
	DnsId string `json:"dns_id,omitempty"`

	// 
	IisId string `json:"iis_id,omitempty"`

	// 
	IisBinding string `json:"iis_binding,omitempty"`

	// 
	IisPath string `json:"iis_path,omitempty"`

	// Уникальное строковое имя сайта (ID).
	IisComments string `json:"iis_comments,omitempty"`

	// 
	Memo string `json:"memo,omitempty"`

	// Дата создания.
	DateReg string `json:"date_reg,omitempty"`

	// Тип веб-сервера.
	Server string `json:"server,omitempty"`

	// 
	ServerBak string `json:"server_bak,omitempty"`

	// 
	ServerAux string `json:"server_aux,omitempty"`

	// Тип сервера недавно изменялся, если true.
	ServerTransition string `json:"server_transition,omitempty"`

	// 
	ServerTransitionDtc string `json:"server_transition_dtc,omitempty"`

	// 
	BlockTransfer string `json:"block_transfer,omitempty"`

	// 
	ServerChangedTime string `json:"server_changed_time,omitempty"`

	// Размер веб-сайта - объем (Кб).
	SizeAmount string `json:"size_amount,omitempty"`

	// Размер веб-сайта - кол-во файлов.
	SizeFileCount string `json:"size_file_count,omitempty"`

	// 
	SizeFileCountLimit string `json:"size_file_count_limit,omitempty"`

	// Размер веб-сайта - дата замера.
	SizeDate string `json:"size_date,omitempty"`

	// 
	SizePriorityScan string `json:"size_priority_scan,omitempty"`

	// 
	CopyLogs string `json:"copy_logs,omitempty"`

	// 
	ContentComments string `json:"content_comments,omitempty"`

	// 
	ContentCommentsVerbose string `json:"content_comments_verbose,omitempty"`

	// 
	MetaSaveCount string `json:"meta_save_count,omitempty"`

	// 
	BaseFolder string `json:"base_folder,omitempty"`

	// 
	VirtualhostConf string `json:"virtualhost_conf,omitempty"`

	// 
	VirtualhostServer string `json:"virtualhost_server,omitempty"`

	// 
	VirtualhostServerConf string `json:"virtualhost_server_conf,omitempty"`

	// 
	LiveDayCount string `json:"live_day_count,omitempty"`

	// 
	ScanDate string `json:"scan_date,omitempty"`

	// 
	GlobalTransferCount string `json:"global_transfer_count,omitempty"`

	// 
	NetLimitFile string `json:"net_limit_file,omitempty"`

	// 
	NetLimitDenyFromIp string `json:"net_limit_deny_from_ip,omitempty"`

	// 
	NetLimitDenyFromAgent string `json:"net_limit_deny_from_agent,omitempty"`

	// 
	ApachePhpPooled string `json:"apache_php_pooled,omitempty"`

	// 
	ApachePhpPooledExt string `json:"apache_php_pooled_ext,omitempty"`

	// 
	ApachePhpPooledExtAuto string `json:"apache_php_pooled_ext_auto,omitempty"`

	// 
	ApachePhpPool1Only string `json:"apache_php_pool1_only,omitempty"`

	// 
	ApachePhpPool5Only string `json:"apache_php_pool5_only,omitempty"`

	// 
	ApacheSsi string `json:"apache_ssi,omitempty"`

	// 
	BypassSecurity string `json:"bypass_security,omitempty"`

	// 
	FlagGenericExec string `json:"flag_generic_exec,omitempty"`

	// 
	FlagNoWww string `json:"flag_no_www,omitempty"`

	// 
	BaseFolderSuffix string `json:"base_folder_suffix,omitempty"`

	// 
	FeedbackSpeed string `json:"feedback_speed,omitempty"`

	// 
	FeedbackSpeedDtc string `json:"feedback_speed_dtc,omitempty"`

	// 
	FeedbackSpeedFeedback string `json:"feedback_speed_feedback,omitempty"`

	// 
	UnixPathOnWindows string `json:"unix_path_on_windows,omitempty"`

	// Ограничение по IP адресам - FTP доступ.
	FtpIpfilter string `json:"ftp_ipfilter,omitempty"`

	// Ограничение по IP адресам - SSH доступ.
	SshIpfilter string `json:"ssh_ipfilter,omitempty"`

	// 
	L3dAuto string `json:"l3d_auto,omitempty"`

	// 
	AwstatsPrimaryDomain string `json:"awstats_primary_domain,omitempty"`

	// 
	SharepointMode string `json:"sharepoint_mode,omitempty"`

	// 
	SharepointModePending string `json:"sharepoint_mode_pending,omitempty"`

	// 
	ApacheGenericPoolPort string `json:"apache_generic_pool_port,omitempty"`

	// 
	MongrelEnvironment string `json:"mongrel_environment,omitempty"`

	// 
	FlagFree string `json:"flag_free,omitempty"`

	// 
	RtmScanDate string `json:"rtm_scan_date,omitempty"`

	// 
	AnalyzeAnalog string `json:"analyze_analog,omitempty"`

	// Включен режим предоставления детализации процессорной нагрузки.
	CpuDetailsEnabled string `json:"cpu_details_enabled,omitempty"`

	// 
	ContentModeratedStatus string `json:"content_moderated_status,omitempty"`

	// 
	ContentModeratedDate string `json:"content_moderated_date,omitempty"`

	// 
	HttpFrontendIp string `json:"http_frontend_ip,omitempty"`

	// 
	HttpFrontendIpTransition string `json:"http_frontend_ip_transition,omitempty"`

	// Дата последнего превышения процессорной нагрузки.
	CpuLimitExceededDate string `json:"cpu_limit_exceeded_date,omitempty"`

	// Признак сайта-конструктора.
	AufsTemplate string `json:"aufs_template,omitempty"`

	// 
	OptionsAutolimit string `json:"options_autolimit,omitempty"`

	// Версия ASP.NET, если отлична от 2.0.
	IisCreationCommands string `json:"iis_creation_commands,omitempty"`

	// 
	IisCreationCommandsUnix string `json:"iis_creation_commands_unix,omitempty"`

	// 
	ThumbDate string `json:"thumb_date,omitempty"`

	// 
	ThumbFailed string `json:"thumb_failed,omitempty"`

	// 
	BackupStatDate string `json:"backup_stat_date,omitempty"`

	// Дата пофайловой резервной копии.
	BackupDate string `json:"backup_date,omitempty"`

	// 
	DetectedPackages string `json:"detected_packages,omitempty"`

	// 
	StatSitePower string `json:"stat_site_power,omitempty"`

	// 
	SmtpFrom string `json:"smtp_from,omitempty"`

	// 
	SuperBackupDate string `json:"super_backup_date,omitempty"`

	// 
	BackupDeltaStatDate string `json:"backup_delta_stat_date,omitempty"`

	// Дата архивной резервной копии.
	BackupDeltaDate string `json:"backup_delta_date,omitempty"`

	// Содержимое архивной резервной копии.
	BackupDeltaDesc string `json:"backup_delta_desc,omitempty"`

	// 
	AltDocrootServer string `json:"alt_docroot_server,omitempty"`

	// 
	AltDocrootPath string `json:"alt_docroot_path,omitempty"`

	// 
	AltDocrootStatus string `json:"alt_docroot_status,omitempty"`

	// 
	AltDocrootStatusCnt string `json:"alt_docroot_status_cnt,omitempty"`

	// 
	AltDocrootStatusDate string `json:"alt_docroot_status_date,omitempty"`

	// Последнее изменение привязок доменов для сайта.
	BindDtc string `json:"bind_dtc,omitempty"`

	// 
	BackupSpecialMode string `json:"backup_special_mode,omitempty"`

	// 
	SizeCheckProblem string `json:"size_check_problem,omitempty"`

	// 
	WpbDomain string `json:"wpb_domain,omitempty"`

	// Для сайта включен конструктор Parallels WPB.
	WpbUuid string `json:"wpb_uuid,omitempty"`

	// 
	WpbStatus string `json:"wpb_status,omitempty"`

	// 
	AdminProtection string `json:"admin_protection,omitempty"`

	// 
	SizeComments string `json:"size_comments,omitempty"`

	// 
	AltDocrootSsdReq string `json:"alt_docroot_ssd_req,omitempty"`

	// 
	MailLimit string `json:"mail_limit,omitempty"`

	// 
	MailAccept string `json:"mail_accept,omitempty"`

	// 
	MailDrop string `json:"mail_drop,omitempty"`

	// FTP/SSH/SCP/SFTP логин.
	FtpName string `json:"ftp_name,omitempty"`

	// FTP/SSH/SCP/SFTP пароль.
	FtpPwd string `json:"ftp_pwd,omitempty"`
}
