/* 
 * 1Gb API
 *
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package swagger

import (
	"strings"
	"fmt"
	"errors"
	"net/url"
	"encoding/json"
)

type VDSHyperVOpenVZApi struct {
	Configuration Configuration
}

func NewVDSHyperVOpenVZApi() *VDSHyperVOpenVZApi {
	configuration := NewConfiguration()
	return &VDSHyperVOpenVZApi{
		Configuration: *configuration,
	}
}

func NewVDSHyperVOpenVZApiWithBasePath(basePath string) *VDSHyperVOpenVZApi {
	configuration := NewConfiguration()
	configuration.BasePath = basePath

	return &VDSHyperVOpenVZApi{
		Configuration: *configuration,
	}
}

/**
 * Изменение параметров VDS
 * Изменение параметров уже существующего VDS
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param type_ Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39;
 * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
 * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
 * @param crHvcpu Количество ядер CPU. По умолчанию 2
 * @param template Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list
 * @param forceMemo 
 * @param hv1gbPanelVersion 
 * @param panelInstall Необходимо ли установить панель 1Gb на VDS
 * @param crSsd1 Создать всю систему на SSD
 * @param crHvAllSystem Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными)
 * @return *string
 */
func (a VDSHyperVOpenVZApi) VdsCreateGet(token_ string, type_ string, crHvmem int32, crHvdsk int32, crHvcpu int32, template string, forceMemo string, hv1gbPanelVersion string, panelInstall bool, crSsd1 bool, crHvAllSystem bool) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/create"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsCreateGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("type_", a.Configuration.APIClient.ParameterToString(type_, ""))
			queryParams.Add("crHvmem", a.Configuration.APIClient.ParameterToString(crHvmem, ""))
			queryParams.Add("crHvdsk", a.Configuration.APIClient.ParameterToString(crHvdsk, ""))
			queryParams.Add("crHvcpu", a.Configuration.APIClient.ParameterToString(crHvcpu, ""))
			queryParams.Add("template", a.Configuration.APIClient.ParameterToString(template, ""))
			queryParams.Add("forceMemo", a.Configuration.APIClient.ParameterToString(forceMemo, ""))
			queryParams.Add("hv1gbPanelVersion", a.Configuration.APIClient.ParameterToString(hv1gbPanelVersion, ""))
			queryParams.Add("panelInstall", a.Configuration.APIClient.ParameterToString(panelInstall, ""))
			queryParams.Add("crSsd1", a.Configuration.APIClient.ParameterToString(crSsd1, ""))
			queryParams.Add("crHvAllSystem", a.Configuration.APIClient.ParameterToString(crHvAllSystem, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Удаление VDS
 * Предоставляет функционал для удаления VDS
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID виртуального сервера, полученный из /vds/list
 * @param forceCritical Если true, VDS будет удален срочно
 * @return *string
 */
func (a VDSHyperVOpenVZApi) VdsDeleteGet(token_ string, key_ int32, forceCritical bool) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/delete"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsDeleteGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsDeleteGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
			queryParams.Add("forceCritical", a.Configuration.APIClient.ParameterToString(forceCritical, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Добавление IP на VDS
 * Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID виртуального сервера, полученный из /vds/list
 * @return *string
 */
func (a VDSHyperVOpenVZApi) VdsIpAddGet(token_ string, key_ int32) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/ip/add"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpAddGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsIpAddGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Удаление IP с VDS
 * Этот вызов позволяет отвязать IP адрес от VDS
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID виртуального сервера, полученный из /vds/list
 * @param delIp IP адрес, который необходимо удалить
 * @return *string
 */
func (a VDSHyperVOpenVZApi) VdsIpDeleteGet(token_ string, key_ int32, delIp string) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/ip/delete"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet")
	}
	// verify the required parameter 'delIp' is set
	if &delIp == nil {
		return new(string), nil, errors.New("Missing required parameter 'delIp' when calling VDSHyperVOpenVZApi->VdsIpDeleteGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
			queryParams.Add("delIp", a.Configuration.APIClient.ParameterToString(delIp, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Список IP-адресов виртуальных серверов
 * Список IP-адресов виртуальных серверов
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID виртуального сервера, полученный из /vds/list
 * @return []InlineResponse20011
 */
func (a VDSHyperVOpenVZApi) VdsIpListGet(token_ string, key_ int32) ([]InlineResponse20011, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/ip/list"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new([]InlineResponse20011), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsIpListGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new([]InlineResponse20011)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Список виртуальных серверов
 * Позволяет получить список виртуальных серверов
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS
 * @return []InlineResponse20012
 */
func (a VDSHyperVOpenVZApi) VdsListGet(token_ string, key_ int32) ([]InlineResponse20012, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/list"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new([]InlineResponse20012), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsListGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new([]InlineResponse20012)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Перезагрузка VDS
 * Предоставляет функционал для перезагрузки VDS
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID виртуального сервера, полученный из /vds/list
 * @return *string
 */
func (a VDSHyperVOpenVZApi) VdsRebootGet(token_ string, key_ int32) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/reboot"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsRebootGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsRebootGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Список шаблонов виртуальных серверов
 * Позволяет получить список шаблонов виртуальных серверов
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @return []InlineResponse20013
 */
func (a VDSHyperVOpenVZApi) VdsTemplatesListGet(token_ string) ([]InlineResponse20013, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/templates-list"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new([]InlineResponse20013), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsTemplatesListGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new([]InlineResponse20013)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return *successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

/**
 * Создание VDS
 * Создание новых VDS с произвольными характеристиками
 *
 * @param token_ Ключ доступа, полученный при авторизации
 * @param key_ ID виртуального сервера, полученный из /vds/list
 * @param crHvmem Количество доступной памяти в мегабайтах. По умолчанию 2048
 * @param crHvdsk Количество доступных гигабайт диска. По умолчанию 30
 * @param crHvcpu Количество ядер CPU. По умолчанию 2
 * @return *string
 */
func (a VDSHyperVOpenVZApi) VdsUpdateGet(token_ string, key_ int32, crHvmem int32, crHvdsk int32, crHvcpu int32) (*string, *APIResponse, error) {

	var httpMethod = "Get"
	// create path and map variables
	path := a.Configuration.BasePath + "/vds/update"

	// verify the required parameter 'token_' is set
	if &token_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'token_' when calling VDSHyperVOpenVZApi->VdsUpdateGet")
	}
	// verify the required parameter 'key_' is set
	if &key_ == nil {
		return new(string), nil, errors.New("Missing required parameter 'key_' when calling VDSHyperVOpenVZApi->VdsUpdateGet")
	}

	headerParams := make(map[string]string)
	queryParams := url.Values{}
	formParams := make(map[string]string)
	var postBody interface{}
	var fileName string
	var fileBytes []byte

	// add default headers if any
	for key := range a.Configuration.DefaultHeader {
		headerParams[key] = a.Configuration.DefaultHeader[key]
	}
		queryParams.Add("token_", a.Configuration.APIClient.ParameterToString(token_, ""))
			queryParams.Add("key_", a.Configuration.APIClient.ParameterToString(key_, ""))
			queryParams.Add("crHvmem", a.Configuration.APIClient.ParameterToString(crHvmem, ""))
			queryParams.Add("crHvdsk", a.Configuration.APIClient.ParameterToString(crHvdsk, ""))
			queryParams.Add("crHvcpu", a.Configuration.APIClient.ParameterToString(crHvcpu, ""))
	

	// to determine the Content-Type header
	localVarHttpContentTypes := []string{ "application/json",  }

	// set Content-Type header
	localVarHttpContentType := a.Configuration.APIClient.SelectHeaderContentType(localVarHttpContentTypes)
	if localVarHttpContentType != "" {
		headerParams["Content-Type"] = localVarHttpContentType
	}
	// to determine the Accept header
	localVarHttpHeaderAccepts := []string{
		"application/json",
	}

	// set Accept header
	localVarHttpHeaderAccept := a.Configuration.APIClient.SelectHeaderAccept(localVarHttpHeaderAccepts)
	if localVarHttpHeaderAccept != "" {
		headerParams["Accept"] = localVarHttpHeaderAccept
	}
	var successPayload = new(string)
	httpResponse, err := a.Configuration.APIClient.CallAPI(path, httpMethod, postBody, headerParams, queryParams, formParams, fileName, fileBytes)
	if err != nil {
		return successPayload, NewAPIResponse(httpResponse.RawResponse), err
	}
	err = json.Unmarshal(httpResponse.Body(), &successPayload)
	return successPayload, NewAPIResponse(httpResponse.RawResponse), err
}

